#!/usr/bin/perl
use strict;
use warnings;

print "Checking modules....\n";
my $err = 0;
print STDERR "Checking for Getopt::Long... ";
eval {
	require Getopt::Long;
};
if($@){
	print STDERR "- not found! :-(\n";
	$err++;
}
else{
	print STDERR "- found! :-) \n";
}

print STDERR "Checking for LWP::UserAgent... ";
eval {
	require LWP::UserAgent;
};
if($@){
	print STDERR "- not found! :-(\n";
	$err++;
}
else{
	print STDERR "- found! :-) \n";
}

print STDERR "Checking for MP3::Info... ";
eval {
	require MP3::Info;
};
if($@){
	print STDERR "- not found! :-(\n";
	$err++;
}
else{
	print STDERR "- found! :-) \n";
}

print STDERR "Checking for Term::Progressbar... ";
eval {
	require Term::ProgressBar;
};
if($@){
	print STDERR "- not found! :-(\n";
	$err++;
}
else{
	print STDERR "- found! :-) \n";
}

print STDERR "Checking for FileHandle... ";
eval {
	require FileHandle;
};
if($@){
	print STDERR "- not found! :-(\n";
	$err++;
}
else{
	print STDERR "- found! :-) \n";
}

print STDERR "Checking for File::Basename... ";
eval {
	require File::Basename;
};
if($@){
	print STDERR "- not found! :-(\n";
	$err++;
}
else{
	print STDERR "- found! :-) \n";
}

print STDERR "Checking for Data::Dumper... ";
eval {
	require Data::Dumper;
};
if($@){
	print STDERR "- not found! :-(\n";
	$err++;
}
else{
	print STDERR "- found! :-) \n";
}
print STDERR "Checking for URI::Escape... ";
eval {
	require URI::Escape;
};
if($@){
	print STDERR "- not found! :-(\n";
	$err++;
}
else{
	print STDERR "- found! :-) \n";
}

if ($err != 0){
	print STDERR "\nAt least one required module is not available on your system!\n" .
				"Please install the missing modules before running yaydl.\n".
				"The easiest way to do this is using your operating system's package manager.\n" .
				"For instance, 'apt-get install libterm-progressbar-perl'" .
				" would install Term::Progressbar on debian-based systems.\n".
				"See your distribution's documentation for further information.\n" .
				"Installation aborted!\n";
	exit 1;
}
